#include <msp430.h>

/*
 * main.c
 */


// v 1.02


unsigned int i;

void write_char_c(char i_cw);
void write_char(unsigned int i_cw);
void wait001(unsigned long int i_wt);
void demo001();
void show_char(unsigned int i);

unsigned int log_m[30];

int main(void) {
    WDTCTL = WDTPW | WDTHOLD;	// Stop watchdog timer
	P1DIR = 0xFF;					// Set P1.0 - P1.7 to output direction
	P2DIR = 0x7F;					// Set P2.0 - P2.6 to output direction & P2.7 to input
	P1SEL = 0x00;
	P1SEL2 = 0x00;
	P2SEL = 0x00;
	P2SEL2 = 0x00;
	P2REN = 0x80;

	P1OUT = 0x00;
	P2OUT = 0x00;

	demo001();

	P1OUT = 0b11000000;
	P2OUT = 0b10110000;

	do 	P1OUT = 0b11000000;
	while((P2IN & 0x80) == 0x80);

	 for ( i = 1; i < 30; i++ )
	   {
	      log_m[ i ] = 1; // 1 --> unused character
	   }


	i = 1;

	for(;;) {
       if (log_m[i] == 1) {
    	   write_char(i);
    	   wait001(1000);
    	   if ((P2IN & 0x80) == 0x80) show_char(i);
       }
       i++;
       if (i == 27) i = 1;

	}
	return 0;
}

void show_char(unsigned int i) {
unsigned int j;

	log_m[i] = 0;

	 for ( j = 1; j < 10; j++ )
	   {
	      write_char(30);
	      wait001(10000);
	      write_char(i);
	      wait001(10000);
	   }

	wait001(10000);

    do ;
	while((P2IN & 0x80) == 0x80);

    return;
}

void write_char(unsigned int i_cw) {
	switch (i_cw) {
	case  1: { P1OUT = 0b01101101; P2OUT = 0b10110000; return; } //A
	case  2: { P1OUT = 0b10101001; P2OUT = 0b10110000; return; } //b
	case  3: { P1OUT = 0b11001001; P2OUT = 0b10000000; return; } //C
	case  4: { P1OUT = 0b10101100; P2OUT = 0b10110000; return; } //d
	case  5: { P1OUT = 0b11001001; P2OUT = 0b10110000; return; } //E
	case  6: { P1OUT = 0b01001001; P2OUT = 0b10110000; return; } //F
	case  7: { P1OUT = 0b11101001; P2OUT = 0b10100000; return; } //G
	case  8: { P1OUT = 0b00101101; P2OUT = 0b10110000; return; } //H
	case  9: { P1OUT = 0b11010010; P2OUT = 0b10000000; return; } //I
	case 10: { P1OUT = 0b10101100; P2OUT = 0b10000000; return; } //J
	case 11: { P1OUT = 0b00001001; P2OUT = 0b10011010; return; } //K
	case 12: { P1OUT = 0b10001001; P2OUT = 0b10000000; return; } //L
	case 13: { P1OUT = 0b00101101; P2OUT = 0b10000011; return; } //M
	case 14: { P1OUT = 0b00101101; P2OUT = 0b10001001; return; } //N
	case 15: { P1OUT = 0b11101101; P2OUT = 0b10000000; return; } //O
	case 16: { P1OUT = 0b01001101; P2OUT = 0b10110000; return; } //P
	case 17: { P1OUT = 0b11101101; P2OUT = 0b10001000; return; } //Q
	case 18: { P1OUT = 0b01001101; P2OUT = 0b10111000; return; } //R
	case 19: { P1OUT = 0b11100001; P2OUT = 0b10110000; return; } //S
	case 20: { P1OUT = 0b01010010; P2OUT = 0b10000000; return; } //T
	case 21: { P1OUT = 0b10101101; P2OUT = 0b10000000; return; } //U
	case 22: { P1OUT = 0b00001001; P2OUT = 0b10000110; return; } //V
	case 23: { P1OUT = 0b00101101; P2OUT = 0b10001100; return; } //W
	case 24: { P1OUT = 0b00000000; P2OUT = 0b10001111; return; } //X
	case 25: { P1OUT = 0b00010000; P2OUT = 0b10000011; return; } //Y
	case 26: { P1OUT = 0b11000000; P2OUT = 0b10000110; return; } //Z
	case 30: { P1OUT = 0b00000000; P2OUT = 0b10000000; return; } //space
	default: P1OUT = 0x00;
	}
	return;
}

void write_char_c(char i_cw) {
	switch (i_cw) {
	case 'A': { P1OUT = 0b01101101; P2OUT = 0b00110000; return; }
	case 'B': { P1OUT = 0b10101001; P2OUT = 0b00110000; return; }
	case 'X': { P1OUT = 0b00000000; P2OUT = 0b00001111; return; }
	default: P1OUT = 0x00;
	}
	return;
}



void wait001(unsigned long int i_wt) {
	volatile unsigned long int i;	// volatile to prevent optimization
	i = i_wt;					// SW Delay
	do i--;
	while(i != 0);

	return;
}

void demo001() {
	P1OUT = 0x01;
	wait001(10000);
	P1OUT = 0x02;
	wait001(10000);
	P1OUT = 0x04;
	wait001(10000);
	P1OUT = 0x08;
	wait001(10000);
	P1OUT = 0x10;
	wait001(10000);
	P1OUT = 0x20;
	wait001(10000);
//--------------------------------------
	P1OUT = 0x40;
	wait001(10000);
	P1OUT = 0x00;
	P2OUT = 0x10;
	wait001(10000);
	P1OUT = 0x00;
	P2OUT = 0x20;
	wait001(10000);
	P1OUT = 0x00;
	P2OUT = 0x30;
	wait001(10000);
	P1OUT = 0x80;
	P2OUT = 0x00;
	wait001(10000);
//--------------------------------------
	P1OUT = 0x00;
	P2OUT = 0x01;
	wait001(10000);
	P2OUT = 0x02;
	wait001(10000);
	P2OUT = 0x04;
	wait001(10000);
	P2OUT = 0x08;
	wait001(10000);
//--------------------------------------
	P1OUT = 0xFF;
	P2OUT = 0x7F;
	wait001(10000);
	P1OUT = 0x00;
	P2OUT = 0x00;
	wait001(10000);


	return;
}

